package cn.sh.stc.sict.theme.hpgp.controller.mobile;



import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import cn.sh.stc.sict.cloud.common.security.util.SecurityUtils;
import cn.sh.stc.sict.cloud.upms.dto.CurrentUser;
import cn.sh.stc.sict.theme.hpgp.model.HpgpBusyIdlePrediction;
import cn.sh.stc.sict.theme.hphy.model.HphyPatientBase;
import cn.sh.stc.sict.theme.hphy.service.HphyPatientBaseService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.sh.stc.sict.cloud.common.core.util.R;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import cn.sh.stc.sict.theme.hpgp.model.HpHzjl;
import cn.sh.stc.sict.theme.hpgp.service.HpHzjlService;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import javax.annotation.Resource;
import java.io.Serializable;
import java.util.List;

/**
 * (HpHzjl)表控制层
 *
 * @author F_xh
 * @since 2022-08-15 14:14:33
 */
@Slf4j
@RestController
@AllArgsConstructor
@Api(tags = "患者就诊记录")
@RequestMapping("/hpHzjl")
public class HpHzjlController {
    /**
     * 服务对象
     */
    private final HpHzjlService hpHzjlService;
    private final HphyPatientBaseService hphyPatientBaseService;

    @GetMapping("/history/dept/list")
    public R historyDeptList(){
        CurrentUser current = SecurityUtils.getCurrentUser();
        if(ObjectUtil.isEmpty(current)|| StrUtil.isBlank(current.getOpenId())){
            log.error("current = {}", JSONUtil.toJsonStr(current));
            return new R().error("当前的登录人信息异常");
        }
        HphyPatientBase patient = hphyPatientBaseService.getByOpenId(current.getOpenId());
        if(ObjectUtil.isEmpty(patient)||StrUtil.isBlank(patient.getCertId())){
            log.error("patient = {}", JSONUtil.toJsonStr(patient));
            return new R().error("患者信息异常！");
        }
        List<HpgpBusyIdlePrediction> result =  hpHzjlService.listByCertId(patient.getCertId());

        return new R(result);
    }
}
